﻿
#1.文字コードなどの定義
use strict;
use warnings;
use utf8;
use Encode qw/encode decode/;

#2.読み込み用ファイルを開く
my $file1 = 'in02.txt';
open my $fh1, '<', $file1
  or die "Can't open $file1:$!";
  
#2.2.書出し用ファイルを開く
my $file2 = 'out04.txt';
open my $fh2, '>>', $file2
  or die "Can't open $file2:$!";

#2.3.変数を定義する
my $line = "";
my @kanjijiu = ("","","","");
my @kanjishin = ("","","","");
my @bunrui = (0,0,0,0);
my @anchor;
my %komoku;
my %iso;
my @tab = ("","\t","\t\t","\t\t\t");
my $an;


#3.行ごとにファイルを読み込んで分類項目を抽出して加工する
while ($line = <$fh1>) {
	#3.1.ユニコード関係の設定
	$line =decode('utf8', $line);
	$line =~ s/[\?\r\n\f]//g;
	$line =~ s/^\x{FEFF}//;
	#3.2.分類項目を読み取る
	if ($line =~ /^([^\t\s]+)\t([^\t]*)\t([^\t]*)\t([^\t]*)$/){
		$kanjishin[0] =$1;
		$kanjishin[1] =$2;
		$kanjishin[2] =$3;
		$kanjishin[3] =$4;
	}
	else{
		print $fh2 (encode('utf8', "問題あり：".$line."\n"));
	}
	#3.3.分類項目をその前の行の分類項目と比較して、異なる場合該当分類番号を増減する。
	for (my $i = 0; $i < @kanjishin; $i++){
		if ($kanjishin[$i] eq ""){
			last;
		}
		elsif ($kanjishin[$i] ne $kanjijiu[$i] ){
			$bunrui[$i] ++;
			for (my $j = $i+1; $j < @kanjishin; $j++){
				$bunrui[$j] = 0;
			}
			$an = $bunrui[0]."-".$bunrui[1]."-".$bunrui[2]."-".$bunrui[3];
			$komoku{$an} = $kanjishin[$i];
			$iso{$an} = $i;
			@anchor = (@anchor,$an);
			print $fh2 (encode('utf8', $an.$tab[$iso{$an}].$komoku{$an}."\n"));
		}
		$kanjijiu[$i] = $kanjishin[$i];
	}
}
foreach $an (@anchor){
	print $fh2 (encode('utf8', $an.$tab[$iso{$an}].$komoku{$an}."\n"));
}
#5.ファイルを閉じる
close $fh1;
close $fh2;


