﻿
#1.文字コードなどの定義
use strict;
use warnings;
use utf8;
use Encode qw/encode decode/;

#2.読み込み用ファイルを開く
my $file1 = 'in03.txt';
open my $fh1, '<', $file1
  or die "Can't open $file1:$!";
  
#2.2.書出し用ファイルを開く
my $file2 = 'out08.txt';#excelmokuji04.plに同じ
open my $fh2, '>>', $file2
  or die "Can't open $file2:$!";
my $file3 = 'out08(number).txt';#簡番号とアンカーを出力するためのファイル
open my $fh3, '>>', $file3
  or die "Can't open $file3:$!";
  
#2.3.変数を定義する
my $line = "";
my @kanjijiu = ("","","","");
my @kanjishin = ("","","","");
my @bunrui = (0,0,0,0);
my @anchor;
my %komoku;
my %iso;
my @tab = ("","\t","\t\t","\t\t\t");
my $an;
my $bango = {};#無名ハッシュの定義。$bangoとはそのハッシュを指すレファレンス/参照指示で、今のところはまだ中身は空である。
my $number ="";

#3.行ごとにファイルを読み込んで分類項目を抽出して加工する
while ($line = <$fh1>) {
	#3.1.ユニコード関係の設定
	$line =decode('utf8', $line);
	$line =~ s/[\?\r\n\f]//g;
	$line =~ s/^\x{FEFF}//;
	#3.2.分類項目を読み取る
	if ($line =~ /^([^\t]+)\t([^\t]+)\t([^\t]*)\t([^\t]*)\t([^\t]*)$/){
		$number =$1;
		$kanjishin[0] =$2;
		$kanjishin[1] =$3;
		$kanjishin[2] =$4;
		$kanjishin[3] =$5;
	}
	else{
		print $fh2 (encode('utf8', "問題あり：".$line."\n"));
	}
	#3.3.分類項目をその前の行の分類項目と比較して、異なる場合該当分類番号を増減する。
	for (my $i = 0; $i < @kanjishin; $i++){
		if ($kanjishin[$i] eq ""){
			last;
		}
		elsif ($kanjishin[$i] ne $kanjijiu[$i] ){
			$bunrui[$i] ++;
			for (my $j = $i+1; $j < @kanjishin; $j++){
				$bunrui[$j] = 0;
			}
			$an = $bunrui[0]."-".$bunrui[1]."-".$bunrui[2]."-".$bunrui[3];
			$komoku{$an} = $kanjishin[$i];
			$iso{$an} = $i;
			@anchor = (@anchor,$an);
		}
		$kanjijiu[$i] = $kanjishin[$i];
	}
	$bango->{$an} ||= [];#今回のアンカーに対応するため簡番号の配列がまだできていない場合に備えて空の配列を作成。
	@{$bango->{$an}} = (@{$bango->{$an}},$number);#簡番号配列に新しい番号を追加
}

my $checkrecords = 0;
foreach $an (@anchor){
	print $fh2 (encode('utf8', $an.$tab[$iso{$an}].$komoku{$an}."\n"));
	print $fh3 (encode('utf8', $an.$tab[$iso{$an}].$komoku{$an}."\n"));
	if (exists $bango->{$an}){
		for my $i (@{$bango->{$an}}) {
   			print $fh3 (encode('utf8', $i."\n"));
   			$checkrecords ++;
   		}
   	}
	#print $fh3 (encode('utf8', join("," @{$bango->{$an}})));
}
print (encode('cp932',"outputted $checkrecords records"));
#5.ファイルを閉じる
close $fh1;
close $fh2;


