﻿
#1.文字コードなどの定義
use strict;
use warnings;
use utf8;
use Encode qw/encode decode/;

#2.HTMLのHead部分の情報を取得
#2.1読み込み用ファイルを開く
my $file1 = 'filehead(Goichi).txt';
open my $fh1, '<', $file1
  or die "Can't open $file1:$!";
#2.2.変数の定義
my $line = "";
my @head;
#2.3.ファイル情報の読み込み
while ($line = <$fh1>) {
	#2.3.1.ユニコード関係の設定
	$line =decode('utf8', $line);
	$line =~ s/[\?\r\n\f]//g;
	$line =~ s/^\x{FEFF}//;
	#2.3.2.変数への各の
	@head = (@head,$line);
}
close $fh1;

#3.釈読等情報の獲得
#3.1.読み込み用ファイルを開く
my $file2 = 'shakudokujoho(Goichi).txt';
open my $fh2, '<', $file2
  or die "Can't open $file2:$!";
my $file3 = 'log.txt';#デバッグに使う
open my $fh3, '>', $file3
  or die "Can't open $file3:$!";

#3.2.変数を定義する
#3.2.1.データ読み込みと加工
my @hyodai;
my $bango = "";
my @bango;
my @johoruikei = ("釈読情報","綴合情報","関連簡情報","参考文献");
my $johoichiji ="";
my $joho = {};
#3.2.2.進行状況を監視する
my $kansu = 0;#識別済み簡数を数える
my $quotes = 0;#複数行にわたるレコードの引用符号を数える
my $ruikei = 0;
my $kaisu = 0;#読み込み行数を数える
my $gyosuichiji = 0;#複数行にわたるレコードの行数を数える
my %gyosu;#複数行にわたるレコードの行数を簡番号からアクセスできるように格納する

#3.3.釈読等情報のデータを読み込む
while ($line = <$fh2>) {
	#3.3.1.ユニコード関係の設定
	$line =decode('utf8', $line);
	$line =~ s/[\?\r\n\f]//g;
	$line =~ s/^\x{FEFF}//;
	$kaisu++;

	#3.3.2.簡番号の認識
	unless ($quotes > 0){#複数行レコードの一部であるかどうかを確認。複数行レコードの場合は#3.3.2.～#3.3.4.を飛ばす
		$line =~ s/^([\dsk\+\-]+)//;
		$bango = $1;
	#3.3.3.空行の認識と処理
		if ($line =~ /^\t\t\t\t$/){
			next;
		}
		@bango[$kansu] = $bango;
	#3.3.4.単行レコードの処理
		unless ($line =~ /"/){
			if ($line =~ /^\t([^\t]*)\t([^\t]*)\t([^\t]*)\t([^\t]*)$/){
				$joho->{$bango[$kansu]} ||= [];
				@{$joho->{$bango[$kansu]}} = ($1,$2,$3,$4);
				$kansu++;
				next;
			}
			else{
				print encode('cp932', "問題あり（行77）：".$bango[$kansu]."\t".$line."\n");
				next;
			}
		}
	}
	#3.3.5.複数行にわたるレコードの処理
	#3.3.5.1.複数行セールの残余部分
	if ($quotes % 2 != 0){#「%」は剰余演算子。それで前行に発見された引用符号（"）の数が奇数か偶数かを調べる。奇数なら本行は、複数行レコードの残余部分。
		if ($line =~ /^[^"]+$/){#エクセルでは１セールに三行以上あった場合に、「"」のつく第一行と最終行以外の行にヒットする
			$johoichiji .= "</p>\n<p>".$line;
			next;
		}
		elsif ($line =~ s/^([^\t"]+)"//){#エクセルでは１セールに二行以上あった場合に最終行にヒットする。
			$johoichiji .= "</p>\n<p>".$1;
			$joho->{$bango[$kansu]}->[$ruikei] = $johoichiji;
			$johoichiji = "";
			if ($ruikei >= 3){
				$ruikei = 0;
				$quotes = 0;
				$kansu++;
				next;
			}
			$ruikei++;
			$quotes++;
		}
		elsif ($line =~ s/^"$//){#複数行セールの最終行が空の場合にヒットする
			$joho->{$bango[$kansu]}->[$ruikei] = $johoichiji;
			if ($ruikei >= 3){
				$ruikei = 0;
				$quotes = 0;
				$kansu++;
				next;
			}
			$johoichiji = "";
			$ruikei++;
			$quotes++;
		}
		else{
			print encode('cp932', "問題（行114）あり：".$bango[$kansu]."\t情報類型".$ruikei."\t".$line."\n");
		}
	}

	#3.3.5.2.複数行レコード内の単行セールへの対応
	while ($line =~ /^\t[^"]/ || $line =~ /^\t$/){
		$line =~ s/^\t([^\t]*)//;
		$joho->{$bango[$kansu]} ||= [];
		$joho->{$bango[$kansu]}->[$ruikei] = $1;
		if ($ruikei >= 3){
			$ruikei = 0;
			$quotes = 0;
			$kansu++;
			next;
		}
		$ruikei++;
	}
	#3.3.5.3.複数行セールの冒頭部分
	if ($line =~ s/^\t"([^\t]+)$//){
		$johoichiji = $1;
		$quotes++;
		next;
	}
	if ($line =~ /.+/){
		print encode('cp932', "問題（行136）あり：".$bango[$kansu]."\t情報類型".$ruikei."\t".$line."\n");
	}
}

#4.ファイル作成
#4.1.変数定義
my $markerp1 ="<p>";
my $markerp2 ="</p>";

#4.2.番号順にファイル作成と情報書込み
my $dir = "Goichi-shakudoku";
mkdir $dir
  or die "Can't open dir $dir:$!";
for (my $i = 0; $i < @bango; $i++)  {
	$bango = $bango[$i];
	#4.2.1ファイルを開く
	my $file4 = "Goichi-shakudoku/$bango.html";
	open my $fh4, ">", $file4
	  or die "Can't open $file4:$!";
	#4.2.2.<head>の作成
	for (my $j = 0; $j < @head; $j++)  {
		my $head = $head[$j];
		$head =~ s/簡番号/$bango/g;
		print $fh4 encode('utf8', $head."\n");
	}
	#4.2.3情報類型のデータを書き込む.
	for (my $k = 0; $k < 4; $k++) {
			$johoichiji = $joho->{$bango}->[$k];
			unless ($johoichiji eq ""){
				print $fh4 (encode('utf8', $markerp1.$johoruikei[$k]."：".$johoichiji.$markerp2."\n"));
			}
	}
   	close $fh4;
}

#5.ファイル作成の簡番号を記録
my $file5 = "shakudokujoho(Goichi-Kanbango).txt";
open my $fh5, ">", $file5
  or die "Can't open $file5:$!";
my @sorted = sort {$a cmp $b} @bango;
foreach $bango (@sorted)  {
	print $fh5 (encode('utf8',$bango."\n"));
}

#6.ファイルを閉じる
close $fh1;
close $fh2;
close $fh3;
close $fh5;

