﻿
#1.文字コードなどの定義
use strict;
use warnings;
use utf8;
use Encode qw/encode decode/;

#2.読み込みと書出し用のファイルを開く
my $file1 = 'honbunin.txt';
open my $fh1, '<', $file1
  or die "Can't open $file1:$!";
  
my $file2 = 'honbunout02.txt';
open my $fh2, '>>', $file2
  or die "Can't open $file2:$!";

#3.行単位でファイルの内容を読み込んで「@hairetu」という配列変数に格納する
my @honbun;
my $line ="";
my $gyo = "";
my $hon1 = "<p>";
my $hon2 = "</p>";
my $hon3 = "</p>\n<p>";
my $hon4 = "<p>　</p>";
my $kansu = -1;

while ($line = <$fh1>) {
	#3.1.ユニコード関係の設定
	$line =decode('utf8', $line);
	$line =~ s/[\?\r\n\f]//g;
	$line =~ s/^\x{FEFF}//;
	$line =~ s/"//;
	
	#3.2.本文行を整えつつ配列に新しい行を追加
	if ($line =~ s/^([\dsk\+\-]+)(\t)([^\t]*)/$3$2$1/){
		$kansu++;
		$gyo = $hon1.$line.$hon2;
		@honbun = (@honbun,$gyo);
	}
	else {
		$honbun[$kansu] =~ s/(\t[\dsk\+\-]+)/$hon3$line$1/;
	}
}

#4.「@honbun」という配列変数から行単位で文字列を読み取り、ファイルに出力する。
for (my $i = 0; $i < @honbun; $i++){
	#4.1.ユニコード関係の設定
	$line =encode('utf8', $honbun[$i]);
	#4.2.出力
	print $fh2 ($line."\n");
}
my $number = @honbun;
print (encode('cp932',"outputted $number records"));

#5.ファイルを閉じる
close $fh1;
close $fh2;