﻿
#1.文字コードなどの定義
use strict;
use warnings;
use utf8;
use Encode qw/encode decode/;

#2.読み込み用ファイルを開く
my $file1 = 'head(hyo).txt';
open my $fh1, '<', $file1
  or die "Can't open $file1:$!";
my $file2 = 'in(hyo).txt';
open my $fh2, '<', $file2
  or die "Can't open $file2:$!";
  
#2.2.書出し用ファイルを開く
my $file3 = 'Goichi-horyoichiran.html';#作る予定のファイルによって適宜変更。
open my $fh3, '>', $file3
  or die "Can't open $file3:$!";
my $file4 = 'log.txt';#デバッグに使う
open my $fh4, '>', $file4
  or die "Can't open $file4:$!";
  
#2.3.変数を定義する
#2.3.1.データ読み込みと加工
my $line = "";
my @hyodai;
my $bango = "";
my @bango;
my $horyoichiji ="";
my $horyo = {};
#2.3.2.進行状況を監視する
my $kaisu = 0;#読み込み行数を数える
my $kansu = 0;#識別済み簡数を数える
my $quotes = 0;#複数行にわたるレコードの引用符号を数える
my $gyosuichiji = 0;#複数行にわたるレコードの行数を数える
my %gyosu;#複数行にわたるレコードの行数を簡番号からアクセスできるように格納する
#2.3.3.表の書式などを整える
my $hyodai ="五一広場後漢簡牘法量等一覧（番号順）";
my $markerp1 ="<p>";#複数行レコードにおいて改行を実現する
my $markerp2 ="</p>";
my $markerh1 ="<h2>";#表全体の標題
my $markerh2 ="</h2>\n  <table style=\"width: 1000px;\">\n";
my $markertrh ="\t<tr style=\"background-color: D7D4D4\">";#「D7D4D4」は表の標題行の背景色を決める。色を変えるには、RGBカラーチャートから色コードを選んでここの「D7D4D4」を上書きする。
my $markertr1 ="\t<tr>";
my $markertr2 ="\t</tr>";
my $markerth1 ="\t\t<th class=\"center bottom\" style=\"width: ";#標題行のマーカー。markerth1とmarkerth2の間に幅を@habaで指定する
my $markerth2 ="px;\">";
my $markerth3 ="</th>";
my @haba =(200,50,220,50,220,100,100,60);#列の幅を決める。変更する場合は、常に合計が1000になるように朝政をする。
my $markertdmiddle1 ="\t\t<td class=\"middle\" id=\"";#簡番号を上下の中央揃えに配置する
my $markertdmiddle2 ="\">";
my $markertdcenter ="\t\t<td class=\"center\">";
my $markertd2 ="</td>";

#3.<head>部分を読み込んで、標題を置き換えて出力
while ($line = <$fh1>) {
	#3.1.ユニコード関係の設定
	$line =decode('utf8', $line);
	$line =~ s/[\?\r\n\f]//g;
	$line =~ s/^\x{FEFF}//;
	$line =~ s/標題/$hyodai/;
	print $fh3 (encode('utf8', $line."\n"));
}
print $fh3 (encode('utf8', "\n"));
print $fh3 (encode('utf8', $markerh1.$hyodai.$markerh2));#表本体の標題

#4.法量等のデータを読み込む
while ($line = <$fh2>) {
	#4.1.ユニコード関係の設定
	$line =decode('utf8', $line);
	$line =~ s/[\?\r\n\f]//g;
	$line =~ s/^\x{FEFF}//;
	#4.2.標題簡を識別して出力
	$kaisu++;
	if ($kaisu == 1){
		if ($line =~ /^([^\t]+)\t([^\t]+)\t([^\t]*)\t([^\t]*)\t([^\t]*)\t([^\t]*)\t([^\t]*)\t([^\t]*)$/){
			$hyodai[0] =$1;
			$hyodai[1] =$2;
			$hyodai[2] =$3;
			$hyodai[3] =$4;
			$hyodai[4] =$5;
			$hyodai[5] =$6;
			$hyodai[6] =$7;
			$hyodai[7] =$8;
			print $fh3 (encode('utf8', $markertrh."\n"));
			for (my $i= 0; $i < @hyodai; $i++){
				print $fh3 (encode('utf8', $markerth1.$haba[$i].$markerth2.$hyodai[$i].$markerth3."\n"));
			}
			print $fh3 (encode('utf8', $markertr2."\n"));
			next;
		}
		else{
			print $fh4 (encode('utf8', "問題あり：".$line."\n"));
		}
	}
	#4.3.複数行にわたるレコードの検出
	if ($quotes > 0 || $line =~ /"/){
		if ($quotes == 0){
			$line =~ s/^([\dsk\+\-]+)(\t)([^"]*)"/$3$markerp1/;
			@bango[$kansu] = $1;
			$horyoichiji = $line.$markerp2;
			$quotes++;
			$gyosuichiji++;
		}
		elsif ($line =~ s/"(\t[^\t]*\t)"/$markerp2$1$markerp1/){
			$horyoichiji .= $line.$markerp2;
			$quotes = $quotes + 2;
			$gyosuichiji++;
		}
		elsif ($line =~ s/"/$markerp2/){
			$horyoichiji .= $line;
			$quotes++;
			$gyosuichiji++;
		}
		else {
			$horyoichiji .= "<p>".$line."</p>";
			$gyosuichiji++;
			if ($quotes ==1){
				$gyosuichiji++;
			}
		}
		if ($quotes == 4) {
			if ($horyoichiji =~ /^([^\t]*)\t([^\t]*)\t([^\t]*)\t([^\t]*)\t([^\t]*)\t([^\t]*)\t([^\t]*)$/){
				$horyo->{$bango[$kansu]} ||= [];
				@{$horyo->{$bango[$kansu]}} = ($1,$2,$3,$4,$5,$6,$7);
				$horyoichiji = "";
				$kansu++;
				$quotes = 0;
				$gyosu{$bango[$kansu]} = $gyosuichiji;
				next;
			}
			else{
				print $fh4 (encode('utf8', "問題あり：".$line."\n".$horyoichiji."\n"));
				next;
			}
		}
		next;
	}
	#4.4.単行レコードの処理
	if ($line =~ /^([\dsk\+\-]+)\t([^\t]*)\t([^\t]*)\t([^\t]*)\t([^\t]*)\t([^\t]*)\t([^\t]*)\t([^\t]*)$/){
		$bango[$kansu] = $1;
		$horyo->{$bango[$kansu]} ||= [];
		@{$horyo->{$bango[$kansu]}} = ($2,$3,$4,$5,$6,$7,$8);
		$horyoichiji = "";
		$kansu++;
	}
	else{
		print $fh4 (encode('utf8', "問題あり：".$line."\n".$kansu."\n"));
		next;
	}
}

#5.法量情報を番号順に表本体として出力
my @sorted =sort {$a cmp $b} @bango;
foreach $bango (@sorted){
	print $fh3 (encode('utf8', $markertr1."\n"));
	print $fh3 (encode('utf8', $markertdmiddle1.$bango.$markertdmiddle2.$bango.$markertd2."\n"));
	if (exists $horyo->{$bango}){
		for my $i (@{$horyo->{$bango}}) {
			
			print $fh3 (encode('utf8', $markertdcenter.$i.$markertd2."\n"));
   		}
   	}
   	print $fh3 (encode('utf8', $markertr2."\n"));
	#print $fh3 (encode('utf8', join("," @{$bango->{$an}})));
}
print $fh3 (encode('utf8', "</table>\n"));

#5.ファイルを閉じる
close $fh1;
close $fh2;
close $fh3;
close $fh4;
