﻿
#1.文字コードなどの定義
use strict;
use warnings;
use utf8;
use Encode qw/encode decode/;

#2.読み込みと書出し用のファイルを開く
#2.1.読み込み用ファイル（ファイル名は「in.txt」、全ての関連変数に序数「1」を付ける。「in.txt」というファイルを事前に用意する必要あり）
my $file1 = 'in.txt';
open my $fh1, '<', $file1
  or die "Can't open $file1:$!";
  
#2.1.書出し用ファイル（ファイル名は「out.txt」、全ての関連変数に序数「2」を付ける。「out.txt」は用意する必要がない。既に存在すれば、その末尾から追記することとなるから、事前に既存のファイルを削除する必要が生じる場合もある）
my $file2 = 'out.txt';
open my $fh2, '>>', $file2
  or die "Can't open $file2:$!";

#3.行単位でファイルの内容を読み込んで「@hairetu」という配列変数に格納する
my @kanji;
my $line = "";
my @bunrui;
my $bunrui1 = 0;
my $bunrui2 = 0;
my $bunrui3 = 0;
my $bunrui4 = 0;
my $anchor = "";

while ($line = <$fh1>) {
	#3.1.ユニコード関係の設定
	$line =decode('utf8', $line);
	$line =~ s/\?//;
	$line =~ s/\r//;
	$line =~ s/\n//;
	#3.2.半角スペースを挿入
	$line =~ s/([^\t])/ $1/g;
	#3.3.新しい行を配列に追加
	@kanji =(@kanji,$line);
	#3.4.リンクのアンカーを作成
	if ($line =~ /^([^\t]+)/) {
		$bunrui1 += 1;
		$bunrui2 = 0;
		$bunrui3 = 0;
		$bunrui4 = 0;
	}
	else {
		if ($line =~ /^\t([^\t]+)/) {
			$bunrui2 += 1;
			$bunrui3 = 0;
			$bunrui4 = 0;
		}
		else {
			if ($line =~ /^\t\t([^\t]+)/) {
				$bunrui3 += 1;
				$bunrui4 = 0;
			}
			else {
				if ($line =~ /^\t\t\t([^\t]+)/) {
					$bunrui4 += 1;
				}
			}
		}
	}
	$anchor = $bunrui1.$bunrui2.$bunrui3.$bunrui4;
	@bunrui = (@bunrui,$anchor)
}

#4.「@kanji」と「@bunrui」という配列変数から行単位で文字列を読み取り、ファイルに出力する。
for (my $i = 0; $i < @kanji; $i++){
	#4.1.ユニコード関係の設定
	$line = encode('utf8', $kanji[$i]);
	$anchor = encode('utf8', $bunrui[$i]);
	#4.2.出力
	print $fh2 ($line."\t".$anchor."\n");
}
#5.ファイルを閉じる
close $fh1;
close $fh2;