﻿
#1.文字コードなどの定義
use strict;
use warnings;
use utf8;
use Encode qw/encode decode/;

#2.読み込み用ファイルを開く
my $file1 = 'in02.txt';
open my $fh1, '<', $file1
  or die "Can't open $file1:$!";
  
#2.2.書出し用ファイルを開く
my $file2 = 'out05.txt';
open my $fh2, '>>', $file2
  or die "Can't open $file2:$!";

#2.3.変数を定義する
my $line = "";
my @kanjijiu = ("","","","");
my @kanjishin = ("","","","");
my @bunrui = (0,0,0,0);
my @anchor;
my %komoku;
my %iso;
my @tab = ("\t","\t\t","\t\t\t","\t\t\t\t");
my $an;
my $ankyu;
my $mae = "<li><a href=\"";
my $naka = "\">";
my $usiro = "</a></li>";
my $ul = "<ul>";
my $kaigyo 	= "\n";
my $ulli = "</ul></li>";
my @menu;
my $isohenka;


#3.行ごとにファイルを読み込んで分類項目を抽出して加工する
while ($line = <$fh1>) {
	#3.1.ユニコード関係の設定
	$line =decode('utf8', $line);
	$line =~ s/[\?\r\n\f]//g;
	$line =~ s/^\x{FEFF}//;
	#3.2.分類項目を読み取る
	if ($line =~ /^([^\t\s]+)\t([^\t]*)\t([^\t]*)\t([^\t]*)$/){
		$kanjishin[0] =$1;
		$kanjishin[1] =$2;
		$kanjishin[2] =$3;
		$kanjishin[3] =$4;
	}
	else{
		print $fh2 (encode('utf8', "問題あり：".$line."\n"));
	}
	#3.3.分類項目をその前の行の分類項目と比較して、異なる場合該当分類番号を増減する。
	for (my $i = 0; $i < @kanjishin; $i++){
		if ($kanjishin[$i] eq ""){
			last;
		}
		elsif ($kanjishin[$i] ne $kanjijiu[$i] ){
			$bunrui[$i] ++;
			for (my $j = $i+1; $j < @kanjishin; $j++){
				$bunrui[$j] = 0;
			}
			$an = $bunrui[0]."-".$bunrui[1]."-".$bunrui[2]."-".$bunrui[3];
			$komoku{$an} = $kanjishin[$i];
			$iso{$an} = $i;
			@anchor = (@anchor,$an);
		}
		$kanjijiu[$i] = $kanjishin[$i];
	}
}
#3.4半角スペースを挿入
for my $key (keys %komoku){
	$komoku{$key} =~ s/([^\t])/ $1/g;
}
#3.5．マーカーなどを整えてメニューの行を組み立てる
$an = $anchor[0];
$menu[0] = $tab[0].$mae.$an.$naka.$komoku{$an}.$usiro;
for (my $i = 1; $i < @anchor; $i++){
	$an = $anchor[$i];
	$ankyu = $anchor[$i-1];
	$isohenka = $iso{$ankyu} - $iso{$an};
	while ($isohenka <= -1) {#古い位相は新しい位相より数字が低いから、下位の位相への移動
		$menu[$i-1] =~ s/^(\t+)(<li><)([^\t<]+)(<\/a>)(<\/li>)$/$1$2$3$4$kaigyo$1$ul/;
		$isohenka++;
	}
	while ($isohenka >= 1) {#古い位相は新しい位相より数字が高いから、上位の位相へ戻る移動
		if ($menu[$i-1] =~ /\n/){
			$menu[$i-1] =~ s/^(.+)(\n)(\t)(\t+)([^\t\n]+)$/$1$2$3$4$5$kaigyo$4$ulli/;
		}
		else {
			$menu[$i-1] =~ s/^(\t)(\t+)([^\t]+)$/$1$2$3$kaigyo$2$ulli/;
		}
		$isohenka--;
	}
	$menu[$i] = $tab[$iso{$an}].$mae.$an.$naka.$komoku{$an}.$usiro;
}
#4出力
my $header ="<header id=\"menu\">\n  <div id=\"Container1\">\n    <ul id=\"MenuBar1\" class=\"MenuBarHorizontal\">";
print $fh2 (encode('utf8', $header."\n"));
foreach $line (@menu){
	$line =~ s/\t/  /g;
	print $fh2 (encode('utf8', $line."\n"));
}
$header = "    </ul>\n  </div>\n</header>";
print $fh2 (encode('utf8', $header."\n"));

#5.ファイルを閉じる
close $fh1;
close $fh2;


