﻿
#1.文字コードなどの定義
use strict;
use warnings;
use utf8;
use Encode qw/encode decode/;

#2.読み込みと書出し用のファイルを開く
#2.1.読み込み用ファイル（ファイル名は「in.txt」、全ての関連変数に序数「1」を付ける。「in.txt」というファイルを事前に用意する必要あり）
my $file1 = 'in.txt';
open my $fh1, '<', $file1
  or die "Can't open $file1:$!";
  
#2.1.書出し用ファイル（ファイル名は「out.txt」、全ての関連変数に序数「2」を付ける。「out.txt」は用意する必要がない。既に存在すれば、その末尾から追記することとなるから、事前に既存のファイルを削除する必要が生じる場合もある）
my $file2 = 'out06.txt';
open my $fh2, '>>', $file2
  or die "Can't open $file2:$!";

#3.行単位でファイルの内容を読み込んで「@hairetu」という配列変数に格納する
my @kanji;
my $line = "";
my @bunrui;
my $bunrui1 = 0;
my $bunrui2 = 0;
my $bunrui3 = 0;
my $bunrui4 = 0;
my $anchor = "";
my $isoshin = 1;
my $isokyu = 1;
my $isohenka = 0;
my $kaisu = -1;
my @menu;
my $ul = "<ul>";
my $kaigyo 	= "\n";
my $ulli = "</ul></li>";
my $josu = 0;
my $mi1 = "<h";
my $mi2 = " id=\"";
my $mi3 = "\">";
my $mi4 = "</h";
my $mi5 = ">";
my $midashi = "";
my @midashi;

while ($line = <$fh1>) {
	$kaisu++;#ループの回数を数える
	#3.1.ユニコード関係の設定
	$line =decode('utf8', $line);
	$line =~ s/\?//;
	$line =~ s/\r//;
	$line =~ s/\n//;
	#3.2.半角スペースを挿入
	$line =~ s/([^\t])/ $1/g;
	#3.3.前つづりと後つづりのための変数を定義
	my $mae = "<li><a href=\"";
	my $naka = "\">";
	my $usiro = "</a></li>";
	#3.4.リンクのアンカーを作成。ついでに、位相間移動の情報を記録、メニューのリスト構造を表現するタブを挿入
	if ($line =~ s/^([^\t]+)/$1/) {
		$bunrui1 += 1;
		$bunrui2 = 0;
		$bunrui3 = 0;
		$bunrui4 = 0;
		$isokyu = $isoshin;
		$isoshin = 1;
		$mae = "\t".$mae;
	}
	else {
		if ($line =~ s/^\t([^\t]+)/$1/) {
			$bunrui2 += 1;
			$bunrui3 = 0;
			$bunrui4 = 0;
			$isokyu = $isoshin;
			$isoshin = 2;
			$mae = "\t\t".$mae;
		}
		else {
			if ($line =~ s/^\t\t([^\t]+)/$1/) {
				$bunrui3 += 1;
				$bunrui4 = 0;
				$isokyu = $isoshin;
				$isoshin = 3;
				$mae = "\t\t\t".$mae;
			}
			else {
				if ($line =~ s/^\t\t\t([^\t]+)/$1/) {
					$bunrui4 += 1;
					$isokyu = $isoshin;
					$isoshin = 4;
					$mae = "\t\t\t\t".$mae;
				}
			}
		}
	}
	$anchor = $bunrui1.$bunrui2.$bunrui3.$bunrui4;
	@bunrui = (@bunrui,$anchor);#アンカーを配列に追加する
	@kanji =(@kanji,$line);#項目を配列に追加する
	$josu = $isoshin+1;
	$midashi = $mi1.$josu.$mi2.$anchor.$mi3.$line.$mi4.$josu.$mi5;
	@midashi = (@midashi,$midashi);
	#3.5．マーカーなどを整えて行を組み立てる
#	$mae = $mae.$anchor.$naka;
#	$isohenka = $isokyu - $isoshin;
#	while ($isohenka <= -1) {#古い位相は新しい位相より数字が低いから、下位の位相への移動
#		$menu[$kaisu-1] =~ s/^(\t+)(<li><)([^\t<]+)(<\/a>)(<\/li>)$/$1$2$3$4$kaigyo$1$ul/;
#		$isohenka++;
#	}
#	while ($isohenka >= 1) {#古い位相は新しい位相より数字が高いから、上位の位相へ戻る移動
#		if ($menu[$kaisu-1] =~ /\n/){
#			$menu[$kaisu-1] =~ s/^(.+)(\n)(\t)(\t+)([^\t\n]+)$/$1$2$3$4$5$kaigyo$4$ulli/;
#		}
#		else {
#			$menu[$kaisu-1] =~ s/^(\t)(\t+)([^\t]+)$/$1$2$3$kaigyo$2$ulli/;
#		}
#		$isohenka--;
#	}
#	$line = $mae.$line.$usiro;
#	@menu=(@menu,$line);
}

#4.「@kanji」と「@bunrui」という配列変数から行単位で文字列を読み取り、ファイルに出力する。
for (my $i = 0; $i < @midashi; $i++){
	#4.1.ユニコード関係の設定
	$line = encode('utf8', $midashi[$i]);
	#4.2.出力
	print $fh2 ($line."\n");
}
#5.ファイルを閉じる
close $fh1;
close $fh2;