﻿
#1.文字コードなどの定義
use strict;
use warnings;
use utf8;
use Encode qw/encode decode/;

#2.読み込みと書出し用のファイルを開く
#2.1.読み込み用ファイル（ファイル名は「in.txt」、全ての関連変数に序数「1」を付ける。「in.txt」というファイルを事前に用意する必要あり）
my $file1 = 'Liya-shakumon.html';
open my $fh1, '<', $file1
  or die "Can't open $file1:$!";
  
#2.2.書出し用ファイル（ファイル名は「out.txt」、全ての関連変数に序数「2」を付ける。「out.txt」は用意する必要がない。既に存在すれば、その末尾から追記することとなるから、事前に既存のファイルを削除する必要が生じる場合もある）
my $file2 = 'out.txt';
open my $fh2, '<', $file2
  or die "Can't open $file2:$!";

#2.3.検証結果を書き出すファイルを開く
my $logfile = 'log.txt';
open my $lh, '>', $logfile
  or die "Can't open $logfile:$!";

#3.検証
#3.0目次を読み込む
my $line = "";
my @kenkanji;
my @kenanchorshin;
my @kenanchorjiu;

while ($line = <$fh2>) {
	$line =decode('utf8', $line);
	$line =~ s/\?//g;
	$line =~ s/\r//g;
	$line =~ s/\n//g;
	$line =~ s/^[\t\s]+//;
	$line =~ /^([^\t]+)\t([^\t]+)\t([^\t]+)$/;
	@kenanchorshin = (@kenanchorshin,$1);
	@kenanchorjiu = (@kenanchorjiu,$2);
	@kenkanji = (@kenkanji,$3);
}
close $fh2;

#3.1.釈文ファイルを読み込む
my @kanji;
my @anchorshin;
my @anchorjiu;
my $iso = -1;
my @iso;
my @bunrui = (0,0,0,0,0);
my @mikanji;
my @mianchorjiu;


while ($line = <$fh1>) {
	$line =decode('utf8', $line);
	$line =~ s/\?//g;
	$line =~ s/\r//g;
	$line =~ s/\n//g;
	$line =~ s/^[\t\s]+//;
	#3.1.1.メニュー項目を読み取る
	if ($line =~ /^<ul/){
		$iso ++;
	}
	elsif ($line =~ /^<li>/){
		$bunrui[$iso] ++;
		$line =~ /\#([^\"]+)\">([^<]+)/;
		@anchorjiu = (@anchorjiu,$1);
		@kanji = (@kanji,$2);
		@iso = (@iso,$iso);
		if ($iso >= 6){
			@anchorshin = (@anchorshin,"5より大きい！".$iso."\tアンカー:".$1);
		}
		else {
			@anchorshin = (@anchorshin,$bunrui[0]."-".$bunrui[1]."-".$bunrui[2]."-".$bunrui[3]."-".$bunrui[4]);
		}
	}
	elsif ($line =~ /^<\/u/){
		$bunrui[$iso] = 0;
		$iso --;
	}
	#3.1.2.見出し情報を読み取る
	elsif ($line =~ /^<h2/){
		my $midashi = $line;
		$midashi =~ s/<a[^>]+>//g;
		$midashi =~ s/<\/a>//g;
		$midashi =~ /id\=\"([^\"]+)\">([^<]+)/;
		@mianchorjiu = (@mianchorjiu,$1);
		@mikanji = (@mikanji,$2);
		my $l = @mikanji-1;
	}
}
close $fh1;

#3.2比較をする
for (my $i = 0; $i < @kenkanji; $i++){
#	print $lh (encode('utf8',"目次の漢字項目：".$kenkanji[$i]."\tメニューの漢字項目：".$kanji[$i]."\t見出しの漢字項目：".$mikanji[$i]."\n"));
#	print $lh (encode('utf8',"目次の漢字項目：".$kenanchorjiu[$i]."\tメニューの漢字項目：".$anchorjiu[$i]."\t見出しの漢字項目：".$mianchorjiu[$i]."\n"));
	if ($kenkanji[$i] ne $kanji[$i] ){
		print $lh (encode('utf8',"不一致注意：\n目次の漢字項目：".$kenkanji[$i]."\tメニューの漢字項目：".$kanji[$i]."\n"));
	}
	if ($kenkanji[$i] ne $mikanji[$i] ){
		print $lh (encode('utf8',"不一致注意：\n目次の漢字項目：".$kenkanji[$i]."\t見出しの漢字項目：".$mikanji[$i]."\n"));
	}
	if ($kenanchorjiu[$i] ne $anchorjiu[$i] ){
		print $lh (encode('utf8',"不一致注意：\n目次のアンカー：".$kenanchorjiu[$i]."\tメニューのアンカー：".$anchorjiu[$i]."\n"));
	}
	if ($kenanchorjiu[$i] ne $mianchorjiu[$i] ){
		print $lh (encode('utf8',"不一致注意：\n目次のアンカー：".$kenanchorjiu[$i]."\t見出しのアンカー：".$mianchorjiu[$i]."\n"));
	}
	if ($kenanchorshin[$i] ne $anchorshin[$i] ){
		print $lh (encode('utf8',"不一致注意：\n目次のアンカー（新）：".$kenanchorshin[$i]."\tメニューのアンカー（新）：".$anchorshin[$i]."\n"));
	}
}

#4.検証終了の知らせ
	print $lh (encode('utf8',"検証が終了した。"));
close $lh;