﻿
#1.文字コードなどの定義
use strict;
use warnings;
use utf8;
use Encode qw/encode decode/;

#2.関連ファイルを開く。
#2.1.読み込み用ファイル
my $file1 = 'head.txt';
open my $fh1, '<', $file1
  or die "Can't open $file1:$!";

my $file2 = 'in03.txt';
open my $fh2, '<', $file2
  or die "Can't open $file2:$!";
  
my $file3 = 'honbunin.txt';
open my $fh3, '<', $file3
  or die "Can't open $file3:$!";

my $file4 = 'foot.txt';
open my $fh4, '<', $file4
  or die "Can't open $file4:$!";

#2.2.書出し用ファイル
my $file5 = 'Goichi-shakumon.html';
open my $fh5, '>', $file5
  or die "Can't open $file5:$!";
my $logfile = 'log.txt';
open my $lh, '>>', $logfile
  or die "Can't open $logfile:$!";

#3.ヘッダーの読み込みと書出し
#3.1.変数の定義
my $line = "";

#3.2.読み込みと書出し
while ($line = <$fh1>) {
	#3.1.ユニコード関係の設定
	$line =decode('utf8', $line);
	$line =~ s/[\?\r\n\f]//g;
	$line =~ s/^\x{FEFF}//;
	#3.2.出力
	print $fh5 (encode('utf8', $line."\n"));
}
print $fh5 (encode('utf8', "\n"));

#4.分類情報の読み込み
#4.1.変数の定義
my @kanjishin = ("","","","");#分類情報の漢字項目を格納する。
my @kanjijiu = ("","","","");#次の行の処理に備えて漢字項目を保存しておく。
my @bunrui = (0,0,0,0);#アンカー生成のために、分類情報を数字化して格納する。
my @anchor;#全てのアンカーを出現順に格納していく。
my $an;#特定の処理に必要なアンカーを一時格納する。
my %komoku;#アンカーをキーとして漢字項目を保存する。
my %iso;#アンカーをキーとして漢字項目の位相情報を保存する
my $bango = {};#アンカーをキーとして簡番号を内容とする配列にアクセスできる無名ハッシュ。
my $number ="";#特定の処理に必要な簡番号を一時格納する。

#4.2.分類情報の読み込みと加工（excelmokuji04.plから踏襲）
while ($line = <$fh2>) {
	#4.2.1.ユニコード関係の設定
	$line =decode('utf8', $line);
	$line =~ s/[\?\r\n\f]//g;
	$line =~ s/^\x{FEFF}//;
	#4.2.2.簡番号と分類項目を読み取る
	if ($line =~ /^([^\t]+)\t([^\t]+)\t([^\t]*)\t([^\t]*)\t([^\t]*)$/){
		$number =$1;
		$kanjishin[0] =$2;
		$kanjishin[1] =$3;
		$kanjishin[2] =$4;
		$kanjishin[3] =$5;
	}
	else{
		print $lh (encode('utf8', "問題あり：".$line."\n"));
	}
	#4.2.3.分類項目をその前の行の分類項目と比較して、異なる場合アンカーを生成する。
	for (my $i = 0; $i < @kanjishin; $i++){
		if ($kanjishin[$i] eq ""){
			last;
		}
		elsif ($kanjishin[$i] ne $kanjijiu[$i] ){
			$bunrui[$i] ++;
			for (my $j = $i+1; $j < @kanjishin; $j++){
				$bunrui[$j] = 0;
			}
			$an = $bunrui[0]."-".$bunrui[1]."-".$bunrui[2]."-".$bunrui[3];
			$komoku{$an} = $kanjishin[$i];
			$iso{$an} = $i;
			@anchor = (@anchor,$an);
		}
		$kanjijiu[$i] = $kanjishin[$i];
	}
	#4.2.4.アンカーをキーとして簡番号を無名ハッシュに格納する。
	$bango->{$an} ||= [];
	@{$bango->{$an}} = (@{$bango->{$an}},$number);
}

#5.メニューの作成と出力
#5.1.変数の定義
my @menu;#生成されたメニューの各行を格納する
my $mae = "<li><a href=\"";#以下はメニュー行の生成に必要な文字列を格納しておく。
my $naka = "\">";
my $usiro = "</a></li>";
my $ul = "<ul>";
my $kaigyo 	= "\n";
my $ulli = "</ul></li>";
my @tab = ("\t","\t\t","\t\t\t","\t\t\t\t");
my $isohenka;#位相の移動を監視する。
my $ankyu;#前行のアンカーを一時記憶させる。

#5.2半角スペースを挿入（menu05.plから踏襲）
for my $key (keys %komoku){
	$komoku{$key} =~ s/([^\t])/ $1/g;
}
#5.3.加工（menu05.plから踏襲）
$an = $anchor[0];
$menu[0] = $tab[0].$mae.$an.$naka.$komoku{$an}.$usiro;
for (my $i = 1; $i < @anchor; $i++){
	$an = $anchor[$i];
	$ankyu = $anchor[$i-1];
	$isohenka = $iso{$ankyu} - $iso{$an};
	while ($isohenka <= -1) {
		$menu[$i-1] =~ s/^(\t+)(<li><)([^\t<]+)(<\/a>)(<\/li>)$/$1$2$3$4$kaigyo$1$ul/;
		$isohenka++;
	}
	while ($isohenka >= 1) {
		if ($menu[$i-1] =~ /\n/){
			$menu[$i-1] =~ s/^(.+)(\n)(\t)(\t+)([^\t\n]+)$/$1$2$3$4$5$kaigyo$4$ulli/;
		}
		else {
			$menu[$i-1] =~ s/^(\t)(\t+)([^\t]+)$/$1$2$3$kaigyo$2$ulli/;
		}
		$isohenka--;
	}
	$menu[$i] = $tab[$iso{$an}].$mae.$an.$naka.$komoku{$an}.$usiro;
}

#5.4.メニューの出力
my $header ="<header id=\"menu\">\n  <div id=\"Container1\">\n    <ul id=\"MenuBar1\" class=\"MenuBarHorizontal\">";
print $fh5 (encode('utf8', $header."\n"));
foreach $line (@menu){
	print $fh5 (encode('utf8', $line."\n"));
}
$header = "    </ul>\n  </div>\n</header>\n";
print $fh5 (encode('utf8', $header."\n"));

#6.見出し行の生成
#6.1.変数の定義
my %midashi;#見出し行を、アンカーからアクセスできるように格納する。（midashi02.plではスカラ変数に代入してそのまま出力したが、釈文とともに出力できるようにハッシュ変数に変えた
my $josu;#マーカー「<h>」に序数を加えるために一時位相情報を保存する
my $mi1 = "<h";#以下は見出し行生成に必要な文字列を格納しておく。
my $mi2 = " id=\"";
my $mi3 = "\">";
my $mi4 = "</h";
my $mi5 = ">";

#6.2.見出し行の作成
foreach $an (@anchor){
	$josu = $iso{$an}+2;
	$midashi{$an} = $mi1.$josu.$mi2.$an.$mi3.$komoku{$an}.$mi4.$josu.$mi5;
}

#7..釈文を簡単位に纏める
#7.1変数の定義
my @honbun;#簡の単位で釈文を一つの文字列に纏めた上で、出現順に格納する。
my %honbun;#簡の単位で纏めた釈文を、簡番号をキーとしてアクセスできるように格納する。
my $gyo = "";#本文行を一時保存する。
my $kansu = -1;#簡単位の釈文の文字列を数える。
my $hon1 = "<p>";#以下はマーカーやリンクに必要な文字列を格納しておく。
my $hon2 = "</p>";
my $hon3 = "</p>\n<p>";
my $hon4 = "<p>　</p>";
my $zuhanmae = "<a href=\"Goichi-zuhan/";
my $zuhannaka = ".jpg\" target=\"_blank\">";
my $zuhanusiro = "</a>";
my $shakudokumae = "<a href=\"Goichi-shakudoku/";
my $shakudokuusiro = ".html\" target=\"_blank\">釈読情報</a>";
my $yomimae = "<a href=\"Goichi-yomikudashi/";
my $yomiusiro = ".html\" target=\"_blank\">読み下し文</a>";
my $horyomae = "<a href=\"Goichi-horyoichiran.html#";
my $horyousiro = "\" target=\"_blank\">法量等</a>";
my $space = "　　";
my $idmae = " id=\"";
my $idusiro = "\"";

#7.2.簡単位で釈文を纏める（honbun05.plから踏襲）
while ($line = <$fh3>) {
	#7.2.1.ユニコード関係の設定
	$line =decode('utf8', $line);
	$line =~ s/[\?\r\n\f]//g;
	$line =~ s/^\x{FEFF}//;
	#7.2.2.エクセルファイルによる不統一を修正
	$line =~ s/"//;
	$line =~ s/([^\dsk])\s+$/$1/;
	
	#7.2.3.本文行を整えつつ配列に新しい行を追加
	if ($line =~ s/^([\dsk\+\-]+)(\t)([^\t]*)/$3$2$1/){
		$kansu++;
		$gyo = $hon1.$line.$hon2;
		@honbun = (@honbun,$gyo);
	}
	else {
		$honbun[$kansu] =~ s/(\t[\dsk\+\-]+)/$hon3$line$1/;
	}
}

#7.3.アンカーやリンクを設定して、釈文をアンカーからアクセスできるハッシュ変数に渡す（honbun05.plから踏襲）
for (my $i = 0; $i < @honbun; $i++){
	if ($honbun[$i] =~ s/^(<p)([^a]+)(a)([^b]+)(b)(\t)([\dsk\+\-]+)(<\/p>)$/$1$idmae$7$idusiro$2$6$zuhanmae$7$3$zuhannaka$7$3$zuhanusiro$4$6$zuhanmae$7$5$zuhannaka$7$5$zuhanusiro$8\n$hon1$space$horyomae$7$horyousiro$space$shakudokumae$7$shakudokuusiro$space$yomimae$7$yomiusiro$hon2\n$hon4/){
		$honbun{$7} = $honbun[$i];
	}
	elsif ($honbun[$i] =~ s/(<p)([^\t]+)(\t)([\dsk\+\-]+)(<\/p>)$/$1$idmae$4$idusiro$2$3$zuhanmae$4$zuhannaka$4$zuhanusiro$5\n$hon1$space$horyomae$4$horyousiro$space$shakudokumae$4$shakudokuusiro$space$yomimae$4$yomiusiro$hon2\n$hon4/){
		$honbun{$4} = $honbun[$i];
	}
	else {
		print $lh (encode('utf8', $honbun[$i]."\n"));
	}
}

#8.見出しと本文行の出力
print $fh5 (encode('utf8', "<body>\n<p>　</p>\n"));#釈文本体のマーカー

foreach $an (@anchor){#アンカーを順に$anに読み込む
	print $fh5 (encode('utf8', $midashi{$an}."\n"));#アンカーをキーとして見出し行の出力
	if (exists $bango->{$an}){#アンカーをキーとして簡番号の存否を確認の上釈文を出力
		for my $i (@{$bango->{$an}}) {
   			print $fh5 (encode('utf8', $honbun{$i}."\n"));
   		}
   	}
}

#9.本体の末尾を整える
while ($line = <$fh4>) {#foot.txtのデータを読み込む。
	#9.1.ユニコード関係の設定
	$line =decode('utf8', $line);
	$line =~ s/[\?\r\n\f]//g;
	$line =~ s/^\x{FEFF}//;
	#3.2.出力
	print $fh5 (encode('utf8', $line."\n"));
}
print $fh5 (encode('utf8', "\n"));

#10.ファイルを閉じる
close $fh1;
close $fh2;
close $fh3;
close $fh4;
close $fh5;
close $lh;
